package com.lovecoding.resources;

import org.springframework.context.ResourceLoaderAware;
import org.springframework.context.support.ClassPathXmlApplicationContext;
import org.springframework.core.io.Resource;
import org.springframework.core.io.ResourceLoader;

import java.io.IOException;
import java.io.InputStream;

public class BeanDemo {


    public static void main(String[] args) {

        ClassPathXmlApplicationContext context = new ClassPathXmlApplicationContext("bean.xml");
        /**
         * 我们声明了一个 Bean 对象， 里面声明一个Set方法
         * Spring 框架在检查Bean 对象的时候，
         * 自动帮我们注入了 ResourceLoader 对象， 其实就是 ApplicationContext 对象
         */
        ResourceLoaderAwareDemo bean = context.getBean(ResourceLoaderAwareDemo.class);
        ResourceLoader resourceLoader = bean.getResourceLoader();
        /**
         * resourceLoader 这个loader 是怎么获取的， 谁注入的
         * 我想获取 系统文件目录的 文件
         * 我想获取 ClassPath目录的文件 如何区分呢
         * Spring 框架允许我们通过不同的协议 Spring框架内部帮我们处理了 不同的实现类
         * Resource res = ctx.getResource("classpath:bean.xml");
         * Resrouce res = ctx.getResource("file:bean.xml");
         * Resource res = ctx.getResource("http://192.168.18.13:4567/beans.xml");
         */
        Resource resource = resourceLoader.getResource("classpath:lovecoding.txt");
        InputStream inputStream = null;
        try {
            inputStream = resource.getInputStream();
            byte[] n = new byte[1024];
            while ( inputStream.read(n) != -1 ) {
                System.out.println( new String(n) );
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

}
